WinDom: Standard callback functions

- Main Page
- Modules
- Data Structures
- Files
- Related Pages

# Standard callback functions
[Reference documentation]

Group of predefined callback functions attributed by WindCreate(). More...

## Functions
void __CDECL | frm_drw (WINDOW *win, short buff[8], APPvar *app)
| standard callback function to manage redraw event on form
void __CDECL | frm_mvd (WINDOW *win, short buff[8], APPvar *app)
| standard callback function to manage window-moved event on form
void __CDECL | frm_tpd (WINDOW *win, short buff[8], APPvar *app)
| standard callback function to manage window-topped event on form
void __CDECL | frm_fld (WINDOW *win, short buff[8], APPvar *app)
| standard callback function to manage window-fulled event on form
void __CDECL | frm_click (WINDOW *win, short buff[8], APPvar *app)
| standard callback function to manage mouse click event on form
void __CDECL | frm_keyhd (WINDOW *win, short buff[8], APPvar *app)
| standard callback function to manage keyboard event on form
void __CDECL | frm_dstry (WINDOW *win, short buff[8], APPvar *app)
| standard callback function to manage destroy event on form
void __CDECL | std_apterm (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage application-terminated event
void __CDECL | std_cls (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-closed event
void __CDECL | std_tpd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-topped event
void __CDECL | std_mvd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-moved event
void __CDECL | std_szd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-sized event
void __CDECL | std_fld (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-fulled event
void __CDECL | std_icn (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-iconify event
void __CDECL | std_unicn (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-uniconify event
void __CDECL | std_allicn (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-alliconify event
void __CDECL | std_arw (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-arrowed event
void __CDECL | std_sldxy (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage "move-work" actions
void __CDECL | std_dnlnd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window down-up event
void __CDECL | std_uplnd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window line-up event
void __CDECL | std_lflnd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window line-left event
void __CDECL | std_rtlnd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window line-right event
void __CDECL | std_dnpgd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window page-down event
void __CDECL | std_uppgd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window page-up event
void __CDECL | std_rtpgd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window page-right event
void __CDECL | std_lfpgd (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window page-left event
void __CDECL | std_vsld (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window vertical-slider event
void __CDECL | std_hsld (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window horizontal-slider event
void __CDECL | std_dstry (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-destroyed event
void __CDECL | std_btm (WINDOW *, short buff[8], APPvar *app)
| standard callback function to manage window-bottomed event
void __CDECL | std_comp_reflow (COMPONENT *c, long buff[8], APPvar *app)
| standard callback function to manage CM_REFLOW event

## Detailed Description

Group of predefined callback functions attributed by WindCreate().

## Function Documentation

void __CDECL frm_click | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage mouse click event on form Parameters:
  | win | window descriptor
  | buff | content of the WM_FORM message
  | app | application descriptor
manage mouse button events (click!) which occur on forms. This is the standard callback function attached to forms for the WM_XBUTTON event, registered by mt_FormCreate().

void __CDECL frm_drw | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage redraw event on form Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to forms for the WM_REDRAW event, registered by mt_FormCreate()

void __CDECL frm_dstry | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage destroy event on form Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to forms for the WM_DESTROY event, registered by mt_FormCreate(). This function will un-attach all the form data attached to the window when mt_FormCreate() was called.

void __CDECL frm_fld | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-fulled event on form Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to forms for the WM_FULLED event, registered by mt_FormCreate()

void __CDECL frm_keyhd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage keyboard event on form Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to forms for the WM_XKEYBD event, registered by mt_FormCreate()

void __CDECL frm_mvd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-moved event on form Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to forms for the WM_MOVED event, registered by mt_FormCreate()

void __CDECL frm_tpd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-topped event on form Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to forms for the WM_TOPPED event, registered by mt_FormCreate()

void __CDECL std_allicn | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-alliconify event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_ALLICONIFY event, registered by mt_WindCreate() This function will "group" all the windows together and iconified the unified window (in fact, all the windows except win are closed and win is iconified. All of them will have their flag WD_ALLICNF set)

void __CDECL std_apterm | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage application-terminated event Parameters:
  | win | window descriptor (NULL)
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to application for the AP_TERM event, registered by mt_ApplInit() this function will try to terminate cleanly the application by: sending a WM_DESTROY message to all windows unsubscribe from an AV server if any terminate frame support and calling mt_ApplExit(). It's recommanded to write to own apterm callback function, in order to free all the resources your application may have reserved (RSC file, dynamical libraries, etc...)

void __CDECL std_arw | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-arrowed event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_ARROWED event, registered by mt_WindCreate(). Depending on buff[4], the dedicated function is invoked in order to perform the requested action : std_uppgd() for WA_UPPAGE action std_dnpgd() for WA_DNPAGE action std_rtpgd() for WA_RTPAGE action std_lfpgd() for WA_LFPAGE action std_uplnd() for WA_UPLINE action std_dnlnd() for WA_DNLINE action std_rtlnd() for WA_RTLINE action std_lflnd() for WA_LFLINE action

void __CDECL std_btm | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-bottomed event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_BOTTOMED event, registered by mt_WindCreate().

void __CDECL std_cls | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-closed event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_CLOSED event, registered by mt_WindCreate() The function just sends a WM_DESTROY message.

void __CDECL std_comp_reflow | ( | COMPONENT * | c,
|  | long | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage CM_REFLOW event Parameters:
  | c | COMPONENT descriptor
  | buff | component message
  | app | application descriptor
This is the standard callback function that ensures the component contents is adjusted in case any of the contained parts changed its size.

void __CDECL std_dnlnd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window down-up event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard function invoked by std_arw() when the WM_ARROWED message received is for WA_DNLINE action. This function is also attached to the WM_DNLINE windom message by mt_WindCreate(). This feature is unused at the moment.

void __CDECL std_dnpgd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window page-down event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard function invoked by std_arw() when the WM_ARROWED message received is for WA_DNPAGE action. This function is also attached to the WM_DNPAGE windom message by mt_WindCreate(). This feature is unused at the moment.

void __CDECL std_dstry | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-destroyed event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_DESTROYED event, registered by mt_WindCreate() This function will close and delete the window, and then terminate the application (by sending a AP_TERM message) if there is no more opened window left.

void __CDECL std_fld | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-fulled event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_FULLED event, registered by mt_WindCreate() This function will restore the previous window position and size if the WS_FULLSIZE flag is set, or will set the window position and size to its maximum size otherwise. changed the flag WS_FULLSIZE send to itself a redraw message if needed recompute the sliders

void __CDECL std_hsld | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window horizontal-slider event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_HSLID event, registered by mt_WindCreate().

void __CDECL std_icn | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-iconify event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_ICONIFY event, registered by mt_WindCreate() This function will : iconify the window (WF_ICONIFY), put it at the bottom of the screen (WF_BOTTOM) change the window name (WF_NAME) if a particular name has been specified for the window when iconified (win->icon.name)

void __CDECL std_lflnd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window line-left event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard function invoked by std_arw() when the WM_ARROWED message received is for WA_LFLINE action. This function is also attached to the WM_LFLINE windom message by mt_WindCreate(). This feature is unused at the moment.

void __CDECL std_lfpgd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window page-left event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard function invoked by std_arw() when the WM_ARROWED message received is for WA_LFPAGE action. This function is also attached to the WM_LFPAGE windom message by mt_WindCreate(). This feature is unused at the moment.

void __CDECL std_mvd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-moved event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_MOVED event, registered by mt_WindCreate() this function will set the new window coordinates (given in buff) and unset the WS_FULLSIZE flag.

void __CDECL std_rtlnd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window line-right event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard function invoked by std_arw() when the WM_ARROWED message received is for WA_RTLINE action. This function is also attached to the WM_RTLINE windom message by mt_WindCreate(). This feature is unused at the moment.

void __CDECL std_rtpgd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window page-right event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard function invoked by std_arw() when the WM_ARROWED message received is for WA_RTPAGE action. This function is also attached to the WM_RTPAGE windom message by mt_WindCreate(). This feature is unused at the moment.

void __CDECL std_sldxy | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage "move-work" actions Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_SLIDEXY event, registered by mt_WindCreate(). This event is defined by windom (it's not a standard message sent by all AESes). This function will update the sliders, and then move the work area of the window with the shift given in buff[4] (dx) and buff[5] (dy).

void __CDECL std_szd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-sized event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_SIZED and WM_REPOSED event, registered by mt_WindCreate() This function will set the new size of the window (given in buff) after saturation by w_min, w_max, h_min and h_max, recompute the sliders, send to itself a redraw message if the content of the window has to be redrawed, and unset the WS_FULLSIZE flag

void __CDECL std_tpd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-topped event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_TOPPED event, registered by mt_WindCreate()

void __CDECL std_unicn | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window-uniconify event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_UNICONIFY event, registered by mt_WindCreate() If the flag WS_ALLICNF is set (this is the unified iconified window), then all the window that has been grouped in this iconified window are re-opened. Then, the window is uniconified (WF_UNICONIFY) and set to the top (WF_TOP).

void __CDECL std_uplnd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window line-up event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard function invoked by std_arw() when the WM_ARROWED message received is for WA_UPLINE action. This function is also attached to the WM_UPLINE windom message by mt_WindCreate(). This feature is unused at the moment.

void __CDECL std_uppgd | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window page-up event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard function invoked by std_arw() when the WM_ARROWED message received is for WA_UPPAGE action. This function is also attached to the WM_UPPAGE windom message by mt_WindCreate(). This feature is unused at the moment.

void __CDECL std_vsld | ( | WINDOW * | win,
|  | short | buff[8],
|  | APPvar * | app
| ) |

  | standard callback function to manage window vertical-slider event Parameters:
  | win | window descriptor
  | buff | AES message
  | app | application descriptor
This is the standard callback function attached to windows for the WM_VSLID event, registered by mt_WindCreate().